//======================================================================================================================

#property copyright "Qimer"

#property link "http://www.metaquotes.net"


extern bool Indication=true;

extern bool min_lot_increase=true;

extern bool Friday=false;

extern bool ManualTrade=false;

extern int FridayHour=10;

extern int StartHour=0;

extern int EndHour=24;

extern int MaxTrades=4;

extern int UseMoney=50;

extern int step=30;

extern int TP=5;

extern int SL_Level=110;

extern double mult=2;

extern double min_lot=0.01;

extern int lot_step=50;

extern int Tral_Size=5;

extern int slippage=3;

extern bool buyclose=false;

extern bool sellclose=false;

extern string s="STOCHASTIC SETTINGS M5";

extern int StochTime_1=5;

extern int per_K_1=10;

extern int per_D_1=3;

extern int slow_1=3;

extern int S_Mode_1=3;

extern int S_Price_1=0;

extern int zoneBUY_1=15;

extern int zoneSELL_1=85;




int tral,cnt,ticketbuy,ticketsell,dig,lot_coef;

double lotsbuy,lotssell,openpricebuy,openpricesell,lotsbuy2,lotssell2,lastlotbuy,lastlotsell,tpb,tps,mtpb,mtps,smbuy,smsell,

free,balance,ask,bid,slb,sls,ordB_TP,ordS_TP,ordB_SL,ordS_SL,ord_Price,ttp_b,ttp_s,MainS_TS, MainB_TS,stop;

bool mod;

color col,colB,colS;

string txt1,txt2,txt3;


//======================================================================================================================

int start() {

double profitbuy=0;

double profitsell=0;

string symbol = Symbol();

double TV=MarketInfo(Symbol(),MODE_TICKVALUE);

double minLot = MarketInfo(Symbol(),MODE_MINLOT);

double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);

double LOTStep = MarketInfo(Symbol(),MODE_LOTSTEP);

tral=Tral_Size;

if (LOTStep==0.01)dig=2;

if (LOTStep==0.1) dig=1;

int totb=Total_B();

int tots=Total_S();



//======================================================================================================================

if(min_lot_increase) {

lot_coef=MathFloor((AccountBalance()*UseMoney/100)/lot_step);

lotsbuy=MathMax(min_lot+(lot_coef-1)*LOTStep,minLot);

lotssell=lotsbuy;

}

else {lotsbuy=MathMax(min_lot,minLot);lotssell=lotsbuy;}


//====================================================    ==============================================

if(totb==0 && time())

{

tpb=0;slb=0;ticketbuy=0;

if (Stochastic("buy") && !ManualTrade && (AccountFreeMarginCheck(Symbol(),OP_BUY,lotsbuy)>0))

{

RefreshRates();

OrderSend(symbol,OP_BUY,NormalizeDouble(lotsbuy,dig),NormalizeDouble(Ask,Digits),slippage,0,0,"2Sides",0,0,Blue);

}

}


if(tots==0 && time())

{

tps=0;sls=0;ticketsell=0;

if (Stochastic("sell") && !ManualTrade && (AccountFreeMarginCheck(Symbol(),OP_SELL,lotssell)>0))

{

RefreshRates();

OrderSend(symbol,OP_SELL,NormalizeDouble(lotssell,dig),NormalizeDouble(Bid,Digits),slippage,0,0,"2Sides",0,0,Red);

}

}


//======================================================================================================================


if(totb>0)

{

double smbuy;

for (cnt=0;cnt<OrdersTotal();cnt++)

{

OrderSelect(cnt,SELECT_BY_POS, MODE_TRADES);

if (OrderSymbol() == symbol && OrderType() == OP_BUY)

{

ticketbuy = OrderTicket();OrderSelect(ticketbuy,SELECT_BY_TICKET, MODE_TRADES);

smbuy+=OrderLots();openpricebuy = OrderOpenPrice();lastlotbuy = OrderLots(); profitbuy+=OrderProfit();

}

}

tpb = NormalizeDouble(Bid+((0-profitbuy)/(smbuy*TV)+TP)*Point,Digits);

if (profitbuy<=0)mtpb=tpb;



if (NormalizeDouble(lastlotbuy*mult,dig)<=maxLot && (AccountFreeMarginCheck(Symbol(),OP_BUY,lastlotbuy*mult)>0))

{

if(Ask<=openpricebuy-step*Point && totb<MaxTrades)

{

lotsbuy2=lastlotbuy*mult;



RefreshRates();

OrderSend(symbol,OP_BUY,NormalizeDouble(lotsbuy2,dig),NormalizeDouble(Ask,Digits),slippage,0,0,"2Sides",0,0,Blue);


}

}

}


//======================================================================================================================


if(tots>0)

{

double smsell;

for (cnt=0;cnt<OrdersTotal();cnt++)

{

OrderSelect(cnt,SELECT_BY_POS, MODE_TRADES);

if (OrderSymbol() == symbol && OrderType() == OP_SELL)

{

ticketsell = OrderTicket();OrderSelect(ticketsell,SELECT_BY_TICKET, MODE_TRADES);

smsell+=OrderLots();openpricesell = OrderOpenPrice();lastlotsell = OrderLots(); profitsell+=OrderProfit();

}

}


tps = NormalizeDouble(Ask-((0-profitsell)/(smsell*TV)+TP)*Point,Digits);

if (profitsell<=0)mtps=tps;



if (NormalizeDouble(lastlotsell*mult,dig)<=maxLot && (AccountFreeMarginCheck(Symbol(),OP_SELL,lastlotsell*mult)>0))

{

if(Bid>=openpricesell+step*Point && tots<MaxTrades)

{

lotssell2=lastlotsell*mult;



RefreshRates();

ticketsell=OrderSend(symbol,OP_SELL,NormalizeDouble(lotssell2,dig),NormalizeDouble(Bid,Digits),slippage,0,0,"2Sides",0,0,Red);


}

}

}


stop=NormalizeDouble(MathAbs(profitbuy+profitsell)/AccountBalance()*100,0);

if (stop>=SL_Level){closeBUYorders();closeSELLorders();}


//======================================================================================================================

if (totb>0 && mtpb>tpb)colB=Yellow;else colB=Blue;

if (tots>0 && mtps<tps)colS=Yellow;else colS=Red;


//======================================================================================================================

if (totb>0 && Bid>tpb)

{

if (Bid<=NormalizeDouble(mtpb,Digits))closeBUYorders();

else if (mtpb<(Bid-tral*Point)) mtpb=NormalizeDouble(Bid-tral*Point,Digits);

}

if (tots>0 && Ask<tps)

{

if (Ask>=NormalizeDouble(mtps,Digits))closeSELLorders();

else if (mtps>(Ask+tral*Point)) mtps=NormalizeDouble(Ask+tral*Point,Digits);

}


if (buyclose)closeBUYorders();

if (sellclose)closeSELLorders();

//======================================================================================================================

free = AccountFreeMargin();balance = AccountBalance();


if (totb==0)

{

profitbuy=0;ticketbuy=0;tpb=0; mtpb=0;

}

if (tots==0)

{

profitsell=0;ticketsell=0;tps=0; mtps=0;

}

if(Indication==true)

{ //    ""  ""

int Balans = NormalizeDouble( AccountBalance(),0);

int Sredstva = NormalizeDouble(AccountEquity(),0);

if (Sredstva >= Balans/6*5) col = DodgerBlue;

if (Sredstva >= Balans/6*4 && Sredstva < Balans/6*5)col = DeepSkyBlue;

if (Sredstva >= Balans/6*3 && Sredstva < Balans/6*4)col = Gold;

if (Sredstva >= Balans/6*2 && Sredstva < Balans/6*3)col = OrangeRed;

if (Sredstva >= Balans/6 && Sredstva < Balans/6*2)col = Crimson;

if (Sredstva < Balans/5 )col = Red;

//-------------------------

ObjectDelete("Lable1");

ObjectCreate("Lable1",OBJ_LABEL,0,0,1.0);

ObjectSet("Lable1", OBJPROP_CORNER, 3);

ObjectSet("Lable1", OBJPROP_XDISTANCE, 10);

ObjectSet("Lable1", OBJPROP_YDISTANCE, 31);

txt1=(DoubleToStr(AccountBalance(), 0));

ObjectSetText("Lable1"," "+txt1+"",12,"Times New Roman",DodgerBlue);

//-------------------------

ObjectDelete("Lable2");

ObjectCreate("Lable2",OBJ_LABEL,0,0,1.0);

ObjectSet("Lable2", OBJPROP_CORNER, 3);

ObjectSet("Lable2", OBJPROP_XDISTANCE, 10);

ObjectSet("Lable2", OBJPROP_YDISTANCE, 11);

txt2=(DoubleToStr(AccountEquity(), 0));

ObjectSetText("Lable2"," "+txt2+"",12,"Times New Roman",col);

Comment(

"\n"," MaxLot = ",NormalizeDouble(maxLot,dig), " TV= ",TV,

"\n"," LotCoef = ",lot_coef, " LotExp = ",mult," Trail = ",tral, "\n",

"---------------------------------------------------------------","\n"," Total Buy = ",Total_B()," Lot = ",smbuy,

"\n"," TakeProfit Buy= ",tpb,

"\n"," Profit Buy = ",profitbuy,"\n",

"---------------------------------------------------------------","\n"," Total Sell = ",Total_S()," Lot = ",smsell,

"\n"," TakeProfit Sell= ",tps,

"\n"," Profit Sell = ",profitsell, "\n",

"---------------------------------------------------------------");

ObjectCreate("Lable3",OBJ_LABEL,0,0,1.0);

ObjectSet("Lable3", OBJPROP_CORNER, 2);

ObjectSet("Lable3", OBJPROP_XDISTANCE, 23);

ObjectSet("Lable3", OBJPROP_YDISTANCE, 11);

txt3="2Sides Stoch Ilan v4.7f "+CharToStr(174)+" Qimer & Kordan";

ObjectSetText("Lable3",txt3,11,"Times New Roman",Peru);

}


//======================================================================================================================


for(int ii=0; ii<2; ii+=2)

{

ObjectDelete("rect"+ii);

ObjectCreate("rect"+ii,OBJ_HLINE, 0, 0,mtps);

ObjectSet("rect"+ii, OBJPROP_COLOR, colS);

ObjectSet("rect"+ii, OBJPROP_WIDTH, 2);

ObjectSet("rect"+ii, OBJPROP_RAY, False);

}

for(int rr=0; rr<2; rr+=2)

{

ObjectDelete("rect1"+rr);

ObjectCreate("rect1"+rr,OBJ_HLINE, 0, 0,mtpb);

ObjectSet("rect1"+rr, OBJPROP_COLOR, colB);

ObjectSet("rect1"+rr, OBJPROP_WIDTH, 2);

ObjectSet("rect1"+rr, OBJPROP_RAY, False);

}

return(0);

}


//======================================================  =======================================================

//======================================================================================================================


int time()

{

if (Friday && DayOfWeek()==5 && Hour()>=FridayHour) return(false);

if (StartHour<EndHour)

{if (Hour()>=StartHour && Hour()<EndHour) return(true); else return(false);}

if (StartHour>EndHour)

{if (Hour()>=EndHour && Hour()<StartHour) return(false); else return(true);}

}

//======================================================================================================================

int Total_B()

{

int j=0;

int r;

for (r=0;r<OrdersTotal();r++)

{

if(OrderSelect(r,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == Symbol())

{

if (OrderType()==OP_BUY) j++;

}

}

return(j);

}

//======================================================================================================================

int Total_S()

{

int d=0;

int n;

for (n=0;n<OrdersTotal();n++)

{

if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == Symbol())

{

if (OrderType()==OP_SELL) d++;

}

}

return(d);

}

//======================================================================================================================


bool Stochastic (string SMode)

{

double sM0 = iStochastic(Symbol(),StochTime_1,per_K_1,per_D_1,slow_1,S_Mode_1,S_Price_1,MODE_MAIN,0);

double sM1 = iStochastic(Symbol(),StochTime_1,per_K_1,per_D_1,slow_1,S_Mode_1,S_Price_1,MODE_MAIN,1);

double sS0 = iStochastic(Symbol(),StochTime_1,per_K_1,per_D_1,slow_1,S_Mode_1,S_Price_1,MODE_SIGNAL,0);

double sS1 = iStochastic(Symbol(),StochTime_1,per_K_1,per_D_1,slow_1,S_Mode_1,S_Price_1,MODE_SIGNAL,1);



if (SMode=="buy")

{

if(sS0<zoneBUY_1 && sM1<sS1 && sM0>=sS0) return(true);

}

if (SMode=="sell")

{

if(sS0>zoneSELL_1 && sM1>sS1 && sM0<=sS0) return(true);

}

return(false);

}



//======================================================================================================================


void closeBUYorders()

{

while(Total_B()>0)

{

for (cnt=0;cnt<OrdersTotal();cnt++)

{

OrderSelect(cnt,SELECT_BY_POS, MODE_TRADES);

if (OrderSymbol() == Symbol() && OrderType() == OP_BUY)

{

RefreshRates();OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),slippage,Blue);

}

}

}

}


//======================================================================================================================

void closeSELLorders()

{

while(Total_S()>0)

{

for (cnt=0;cnt<OrdersTotal();cnt++)

{

OrderSelect(cnt,SELECT_BY_POS, MODE_TRADES);

if (OrderSymbol() == Symbol() && OrderType() == OP_SELL)

{

RefreshRates();OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),slippage,Red);

}

}

}

}

//======================= 